import { ActionContext, ActionTree, MutationTree, Store } from 'vuex';
import { ImmutableFSA, ActionCreator } from './types';
export declare type PayloadType<T> = T extends ActionCreator<infer R> ? R : never;
export declare type ReturnType<T> = T extends (...args: any[]) => infer R ? R : never;
export declare type ActionHandler<S, R, P> = (this: Store<R>, injectee: ActionContext<S, R>, payload: P) => any;
export declare type ActionObject<S, R, P> = {
    root?: boolean;
    handler: ActionHandler<S, R, P>;
};
export declare type Action<S, R, P> = ActionHandler<S, R, P> | ActionObject<S, R, P>;
export declare type Mutation<S, P> = (this: Store<S>, state: S, payload: P) => void;
export declare function action<S, R, A extends ActionCreator<any>>(actionCreator: A, action: Action<S, R, ImmutableFSA<PayloadType<A>>>): ActionTree<S, R>;
export declare function actionToMutation<S, R, A extends ActionCreator<any>>(actionCreator: A): ActionTree<S, R>;
export declare function actionsToMutations<S, R>(...actionCreators: Array<ActionCreator<any>>): ActionTree<S, R>;
export declare function mutation<S, A extends ActionCreator<any>>(actionCreator: A, mutation: Mutation<S, ImmutableFSA<PayloadType<A>>>): MutationTree<S>;
export declare function combineAction<S, R>(...actions: Array<ActionTree<S, R>>): ActionTree<S, R>;
export declare function combineMutation<S>(...mutations: Array<MutationTree<S>>): MutationTree<S>;
