"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function action(actionCreator, action) {
    return {
        [actionCreator.type]: action,
    };
}
exports.action = action;
function actionToMutation(actionCreator) {
    return {
        [actionCreator.type](context, action) {
            context.commit(action);
        },
    };
}
exports.actionToMutation = actionToMutation;
function actionsToMutations(...actionCreators) {
    return actionCreators.reduce((res, v) => Object.assign(res, actionToMutation(v)), {});
}
exports.actionsToMutations = actionsToMutations;
function mutation(actionCreator, mutation) {
    return {
        [actionCreator.type]: mutation,
    };
}
exports.mutation = mutation;
function combineAction(...actions) {
    return actions.reduce((res, v) => Object.assign(res, v), {});
}
exports.combineAction = combineAction;
function combineMutation(...mutations) {
    return mutations.reduce((res, v) => Object.assign(res, v), {});
}
exports.combineMutation = combineMutation;
