export declare type FluxType = string;
export declare type ImmutableFSA<Payload = void> = {
    readonly type: FluxType;
    readonly payload: Readonly<Payload>;
    readonly error?: boolean;
    readonly meta?: any;
};
export declare type Options = Partial<{
    readonly namespace: string;
    readonly error: boolean;
    readonly meta: any;
}>;
export declare type ActionCreator<Payload = void> = {
    readonly type: FluxType;
    (payload: Payload, options?: Options): ImmutableFSA<Payload>;
} & (Payload extends void ? (payload?: Payload, options?: Options) => ImmutableFSA<Payload> : {});
